## fcitx 4.1.2

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project(fcitx)

set(version 4.1.2)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

option(ENABLE_CAIRO "Enable Cairo" ON)
option(ENABLE_DBUS "Enable DBus Support" ON)
option(ENABLE_PANGO "Enable Pango Support" ON)
option(ENABLE_DEBUG "Enable Debug" OFF)
option(ENABLE_TABLE "Enable Table IM" ON)
option(ENABLE_GTK2_IM_MODULE "Enable GTK2 IM Module" ON)
option(ENABLE_GTK3_IM_MODULE "Enable GTK3 IM Module" OFF)
option(ENABLE_QT_IM_MODULE "Enable Qt IM Module" OFF)
option(ENABLE_OPENCC "Enable OpenCC for Chinese Transform" ON)
option(ENABLE_STATIC "Build Static Library" OFF)
option(ENABLE_TEST "Test build" OFF)

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(FindPkgConfig)
include(UseDoxygen OPTIONAL)
include(FcitxMacro)

check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(malloc.h HAVE_MALLOC_H)
check_include_files(stdbool.h HAVE_STDBOOL_H)
check_function_exists(asprintf HAVE_ASPRINTF)

FIND_PACKAGE(Gettext REQUIRED)
FIND_PACKAGE(Libintl REQUIRED)
FIND_PACKAGE(Libiconv REQUIRED)
FIND_PACKAGE(Pthread REQUIRED)
FIND_PACKAGE(Libexecinfo REQUIRED)
FIND_PACKAGE(Libkvm)
FIND_PACKAGE(DL REQUIRED)
FIND_PROGRAM(WGET wget)
FIND_PROGRAM(TAR tar)

FIND_PACKAGE(X11 REQUIRED)

if (ENABLE_TEST)
    ENABLE_TESTING()
endif (ENABLE_TEST)

set(_ENABLE_CAIRO 0)
set(_ENABLE_PANGO 0)
if (ENABLE_CAIRO)
    PKG_CHECK_MODULES(CAIRO_XLIB REQUIRED "cairo-xlib >= 1.0" )
    if (CAIRO_XLIB_FOUND)
        set(_ENABLE_CAIRO 1)
    endif (CAIRO_XLIB_FOUND)
endif (ENABLE_CAIRO)

set(_ENABLE_PANGO 0)
if (_ENABLE_CAIRO)
    if (ENABLE_PANGO)
        PKG_CHECK_MODULES(PANGOCAIRO "pangocairo >= 1.0" )
        if (PANGOCAIRO_FOUND)
            set(_ENABLE_PANGO 1)
        endif (PANGOCAIRO_FOUND)
    endif (ENABLE_PANGO)
    if (NOT _ENABLE_PANGO)
        PKG_CHECK_MODULES(FONTCONFIG REQUIRED "fontconfig")
    endif (NOT _ENABLE_PANGO)
endif(_ENABLE_CAIRO)

set(_ENABLE_DBUS 0)
if (ENABLE_DBUS)
    PKG_CHECK_MODULES(DBUS "dbus-1 >= 1.1.0" )
    if (DBUS_FOUND)
        set(_ENABLE_DBUS 1)
    endif (DBUS_FOUND)
endif (ENABLE_DBUS)

set(_ENABLE_OPENCC 0)
if (ENABLE_OPENCC)
    PKG_CHECK_MODULES(OPENCC "opencc >= 0.1.1" )
    if (OPENCC_FOUND)
        set(_ENABLE_OPENCC 1)
    endif (OPENCC_FOUND)
endif (ENABLE_OPENCC)

if(ENABLE_DEBUG)
    set(_DEBUG)
endif(ENABLE_DEBUG)

set(package     fcitx)
set(prefix      ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(bindir ${exec_prefix}/bin)

if(NOT DEFINED LIB_INSTALL_DIR)
    set(LIB_INSTALL_DIR ${exec_prefix}/lib)
endif()

set(libdir ${LIB_INSTALL_DIR})
set(addondir ${libdir}/${package} )
set(pkgdatadir ${prefix}/share/${package})
set(configdescdir ${pkgdatadir}/configdesc)
set(addonconfigdir ${pkgdatadir}/addon)
set(localedir ${CMAKE_INSTALL_PREFIX}/share/locale)
set(includedir  ${CMAKE_INSTALL_PREFIX}/include)

list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" isSystemDir)
if("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_SKIP_BUILD_RPATH  FALSE)
    set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    set(CMAKE_INSTALL_RPATH "${LIB_INSTALL_DIR}")
    set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif("${isSystemDir}" STREQUAL "-1")

# For FcitxMacro
set(FCITX4_ADDON_INSTALL_DIR ${addondir})
set(FCITX4_CONFIGDESC_INSTALL_DIR ${configdescdir})
set(FCITX4_ADDON_CONFIG_INSTALL_DIR ${addonconfigdir})
set(FCITX4_PACKAGE_NAME ${package})

set(CMAKE_C_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_C_FLAGS}")
set(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_CXX_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_SHARED_LINKER_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--as-needed ${CMAKE_MODULE_LINKER_FLAGS}")
add_definitions("-D_GNU_SOURCE -DFCITX_HAVE_CONFIG_H")

configure_file(${PROJECT_SOURCE_DIR}/config.h.in ${PROJECT_BINARY_DIR}/config.h)
configure_file("${PROJECT_SOURCE_DIR}/cmake/FcitxConfigVersion.cmake.in"
               "${PROJECT_BINARY_DIR}/cmake/FcitxConfigVersion.cmake"
                IMMEDIATE @ONLY
)

include_directories(${PROJECT_BINARY_DIR})

add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(skin)
add_subdirectory(tools)
add_subdirectory(data)
add_subdirectory(po)
add_subdirectory(cmake)

if (ENABLE_TEST)
    add_subdirectory(test)
endif (ENABLE_TEST)

=== test/CMakeLists.txt ===
add_executable(testconfig testconfig.c)
target_link_libraries(testconfig fcitx-config)

add_executable(testmessage testmessage.c)
target_link_libraries(testmessage fcitx-core)

include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/lib)

add_test(NAME testconfig
         COMMAND testconfig ${CMAKE_CURRENT_SOURCE_DIR}/test.desc ${CMAKE_CURRENT_SOURCE_DIR}/test.conf ${CMAKE_CURRENT_BINARY_DIR}/test.conf)

add_test(NAME testmessage
         COMMAND testmessage)

=== data/png/CMakeLists.txt ===
set(FCITX_PNG_32_FILES
fcitx-fullwidth-active.png
fcitx-fullwidth-inactive.png
fcitx-punc-active.png
fcitx-punc-inactive.png
fcitx-vk-active.png
fcitx-vk-inactive.png
)

set(FCITX_PNG_48_FILES
fcitx-cangjie.png
fcitx-chn.png
fcitx-chttrans-active.png
fcitx-chttrans-inactive.png
fcitx-eng.png
fcitx-erbi.png
fcitx-remind-active.png
fcitx-remind-inactive.png
fcitx-pinyin.png
fcitx-wbpy.png
fcitx-wubi.png
fcitx-ziranma.png
fcitx-shuangpin.png
)

foreach(size 16 22 24 32 48 128)
    install(FILES fcitx-${size}.png RENAME fcitx.png DESTINATION share/icons/hicolor/${size}x${size}/apps)
endforeach(size 16 22 24 32 48 128)

install(FILES ${FCITX_PNG_32_FILES} DESTINATION share/icons/hicolor/32x32/status )
install(FILES ${FCITX_PNG_48_FILES} DESTINATION share/icons/hicolor/48x48/status )

=== skin/default/CMakeLists.txt ===
set(FCITX_DEFAULT_SKIN_FILES
chttrans_active.png chttrans_inactive.png
fullwidth_active.png fullwidth_inactive.png
punc_active.png punc_inactive.png
active.png  bingchan.png erbi.png  fcitx_skin.conf 
input.png  remind_active.png remind_inactive.png  quwei.png vk_active.png vk_inactive.png
wubi.png wbpy.png ziranma.png
bar.png cangjie.png  cn.png en.png  inactive.png logo.png
dianbaoma.png shuangpin.png wanfeng.png pinyin.png prev.png next.png keyboard.png menu.png
)

install(FILES ${FCITX_DEFAULT_SKIN_FILES} DESTINATION ${pkgdatadir}/skin/default)

=== src/frontend/CMakeLists.txt ===
add_subdirectory(xim)

if (_ENABLE_DBUS)
    #add_subdirectory(fbterm)
    add_subdirectory(ipc)

    if (ENABLE_GTK2_IM_MODULE OR ENABLE_GTK3_IM_MODULE)

    PKG_CHECK_MODULES(GLIB2 REQUIRED "glib-2.0" )
    PKG_CHECK_MODULES(DBUS_GLIB REQUIRED "dbus-glib-1")

    _pkgconfig_invoke("glib-2.0" GLIB2 GLIB_GENMARSHAL "" "--variable=glib_genmarshal")

    FIND_PROGRAM(GLIB_GENMARSHAL ${GLIB2_GLIB_GENMARSHAL})

    endif (ENABLE_GTK2_IM_MODULE OR ENABLE_GTK3_IM_MODULE)

    add_subdirectory(gtk2)
    add_subdirectory(gtk3)
    add_subdirectory(qt)
endif (_ENABLE_DBUS)

=== src/lib/CMakeLists.txt ===
add_subdirectory(fcitx-config)
add_subdirectory(fcitx-utils)
add_subdirectory(fcitx)

=== src/frontend/qt/CMakeLists.txt ===
if (ENABLE_QT_IM_MODULE)
find_package(Qt4 4.5 COMPONENTS QtCore QtGui QtDBus REQUIRED)
find_package(ICU REQUIRED)

include_directories(
    ${QT_INCLUDE_DIR}
    ${QT_QTCORE_INCLUDE_DIR}
    ${QT_QTGUI_INCLUDE_DIR}
    ${QT_QTDBUS_INCLUDE_DIR}
    ${X11_INCLUDE_DIRS}
    ${DBUS_INCLUDE_DIRS}
    ${ICU_INCLUDE_DIRS}
    ${CMAKE_CURRENT_BINARY_DIR}
)

link_directories(
    ${X11_LIBRARY_DIRS}
    ${DBUS_LIBRARY_DIRS}
)

set(
    qtim_fcitx_SRCS
    fcitx-plugin.cpp
    fcitx-input-context.cpp
    fcitxkeyuni.cpp
)


QT4_ADD_DBUS_INTERFACE(qtim_fcitx_SRCS
    org.fcitx.Fcitx.InputContext.xml
    org.fcitx.Fcitx.InputContext
)

QT4_ADD_DBUS_INTERFACE(qtim_fcitx_SRCS
    org.fcitx.Fcitx.InputMethod.xml
    org.fcitx.Fcitx.InputMethod
)

QT4_ADD_DBUS_INTERFACE(qtim_fcitx_SRCS
    org.freedesktop.DBus.xml
    org.freedesktop.DBus
)


set(
    qtim_fcitx_MOC_HDRS
    fcitx-input-context.h
)

QT4_AUTOMOC(${qtim_fcitx_SRCS})
QT4_WRAP_CPP(
    qtim_fcitx_MOC_SRCS
    ${qtim_fcitx_MOC_HDRS}
)

add_library(
    qtim-fcitx MODULE
    ${qtim_fcitx_SRCS}
    ${qtim_fcitx_MOC_SRCS}
)

set_target_properties( qtim-fcitx PROPERTIES PREFIX "" COMPILE_FLAGS "-fvisibility=hidden" LINK_FLAGS "-Wl,--no-undefined")

target_link_libraries(
    qtim-fcitx
    debug ${QT_QTCORE_LIBRARY_DEBUG}
    debug ${QT_QTDBUS_LIBRARY_DEBUG}
    debug ${QT_QTGUI_LIBRARY_DEBUG}
    optimized ${QT_QTCORE_LIBRARY_RELEASE}
    optimized ${QT_QTDBUS_LIBRARY_RELEASE}
    optimized ${QT_QTGUI_LIBRARY_RELEASE}
    ${X11_LIBRARIES}
    ${ICU_LIBRARIES}
    fcitx-config
)

install(
    TARGETS qtim-fcitx
    LIBRARY DESTINATION
    ${QT_PLUGINS_DIR}/inputmethods)

endif (ENABLE_QT_IM_MODULE)

=== src/im/pinyin/CMakeLists.txt ===

set(FCITX_PINYIN_SOURCES
    py.c
    PYFA.c
    pyMapTable.c
    pyParser.c
    sp.c
    pyconfig.c
)

fcitx_add_addon(fcitx-pinyin ${FCITX_PINYIN_SOURCES})

fcitx_add_addon_header(pinyin pydef.h)
fcitx_add_configdesc_file(fcitx-pinyin.desc)
fcitx_add_addon_conf_file(fcitx-pinyin.conf)

=== src/lib/fcitx-config/CMakeLists.txt ===
set(FCITX_CONFIG_SOURCES
    fcitx-config.c
    hotkey.c
    sprintf.c
    xdg.c
)

set(FCITX_CONFIG_HEADERS
    fcitx-config.h
    hotkey.h
    xdg.h
)

add_library(fcitx-config SHARED ${FCITX_CONFIG_SOURCES})
target_link_libraries(fcitx-config fcitx-utils)
set_target_properties(fcitx-config
                      PROPERTIES VERSION 4.1.0
                      SOVERSION 4.1
                      COMPILE_FLAGS "-fvisibility=hidden"
                      LINK_FLAGS "-Wl,--no-undefined"
)

configure_file(fcitx-config.pc.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx-config.pc)

install(TARGETS fcitx-config DESTINATION ${libdir})
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx-config.pc DESTINATION "${libdir}/pkgconfig")
install(FILES ${FCITX_CONFIG_HEADERS} DESTINATION "${includedir}/fcitx-config")

if (ENABLE_STATIC)

add_library(fcitx-config-static STATIC ${FCITX_CONFIG_SOURCES})
set_target_properties(fcitx-config-static PROPERTIES
    OUTPUT_NAME "fcitx-config"
    PREFIX "lib"
)

install(TARGETS fcitx-config-static
    LIBRARY DESTINATION ${libdir}
    ARCHIVE DESTINATION ${libdir}
)
endif (ENABLE_STATIC)

=== src/lib/fcitx-utils/CMakeLists.txt ===
set(FCITX_UTILS_SOURCES
    utf8.c
    utils.c
    log.c
    qsort_r.c
    msort_r.c
)

set(FCITX_UTILS_HEADERS
    log.h
    utarray.h
    utf8.h
    utils.h
    uthash.h
)

if (LIBKVM_FOUND)
    include_directories(LIBKVM_INCLUDE_DIR)
endif (LIBKVM_FOUND)

add_library(fcitx-utils SHARED ${FCITX_UTILS_SOURCES})
set_target_properties(fcitx-utils
                      PROPERTIES VERSION 0.1.0
                      SOVERSION 0.1
                      COMPILE_FLAGS "-fvisibility=hidden"
                      LINK_FLAGS "-Wl,--no-undefined"
)
target_link_libraries(fcitx-utils ${LIBINTL_LIBRARIES} ${LIBICONV_LIBRARIES})

if (LIBKVM_FOUND)
    target_link_libraries(fcitx-utils ${LIBKVM_LIBRARIES})
endif (LIBKVM_FOUND)

configure_file(fcitx-utils.pc.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx-utils.pc)

install(TARGETS fcitx-utils LIBRARY DESTINATION "${libdir}")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx-utils.pc DESTINATION "${libdir}/pkgconfig")
install(FILES ${FCITX_UTILS_HEADERS} DESTINATION "${includedir}/fcitx-utils")

if (ENABLE_STATIC)

add_library(fcitx-utils-static STATIC ${FCITX_UTILS_SOURCES})
set_target_properties(fcitx-utils-static PROPERTIES
    OUTPUT_NAME "fcitx-utils"
    PREFIX "lib"
)

install(TARGETS fcitx-utils-static
    LIBRARY DESTINATION ${libdir}
    ARCHIVE DESTINATION ${libdir}
)
endif (ENABLE_STATIC)

=== src/lib/fcitx/CMakeLists.txt ===
set(LIBFCITX_SOURCES
    instance.c
    candidate.c
    configfile.c
    profile.c
    addon.c
    frontend.c
    hook.c
    ime.c
    ui.c
    module.c
    keys.c
)

set(FCITX_HEADERS
    candidate.h
    ime.h
    ui.h
    hook.h
    configfile.h
    profile.h
    module.h
    instance.h
    addon.h
    frontend.h
    fcitx.h
    keys.h
)

link_directories(${DL_LIBRARY_DIRS} ${PTHREAD_LIBRARY_DIRS})

add_library(fcitx-core SHARED ${LIBFCITX_SOURCES})
set_target_properties(fcitx-core
                      PROPERTIES VERSION 0.2.0
                      SOVERSION 0.2
                      COMPILE_FLAGS "-fvisibility=hidden"
                      LINK_FLAGS "-Wl,--no-undefined"
)
target_link_libraries(fcitx-core fcitx-config)
configure_file(fcitx.pc.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx.pc)

target_link_libraries(fcitx-core fcitx-config fcitx-utils ${DL_LIBRARIES} ${PTHREAD_LIBRARIES})
install(TARGETS fcitx-core LIBRARY DESTINATION "${libdir}")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx.pc DESTINATION "${libdir}/pkgconfig")
install(FILES ${FCITX_HEADERS} DESTINATION "${includedir}/fcitx")

if (ENABLE_STATIC)

add_library(fcitx-core-static STATIC ${LIBFCITX_SOURCES})
set_target_properties(fcitx-core-static PROPERTIES
    OUTPUT_NAME "fcitx-core"
    PREFIX "lib"
)

install(TARGETS fcitx-core-static
    LIBRARY DESTINATION ${libdir}
    ARCHIVE DESTINATION ${libdir}
)
endif (ENABLE_STATIC)

=== src/module/chttrans/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)

if (_ENABLE_OPENCC)
    include_directories(${OPENCC_INCLUDE_DIRS})
    link_directories(${OPENCC_LIBRARY_DIRS})
endif (_ENABLE_OPENCC)

set(FCITX_CHTTRANS_SOURCES
    chttrans.c
)

fcitx_add_addon(fcitx-chttrans ${FCITX_CHTTRANS_SOURCES})

if (_ENABLE_OPENCC)
    target_link_libraries( fcitx-chttrans ${OPENCC_LIBRARIES} )
    include_directories(${OPENCC_INCLUDE_DIRS})
endif (_ENABLE_OPENCC)

fcitx_add_configdesc_file(fcitx-chttrans.desc)
fcitx_add_addon_conf_file(fcitx-chttrans.conf)

=== debian/changelog ===
fcitx (1:4.1.2-4) unstable; urgency=low

  [ Aron Xu ]
  * Add NoDisplay=true to fcitx.desktop.in file.

  [ YunQiang Su ]
  * Improve the descriotion of fcitx-libs-dbg, as it contains
    all debug symbols of the whole fcitx.

 -- YunQiang Su <wzssyqa@gmail.com>  Fri, 09 Dec 2011 00:09:43 +0800

fcitx (1:4.1.2-3) unstable; urgency=low

  * debian/patches/01-fix_input_percent_sign.patch:
    - [UPSTREAM] Behave correctly when meet percent sign (%).
  * debian/patches/01-run_posix_shell_script.patch:
    - [UPSTREAM] Change from bash to sh.
  * debian/control:
    + Recommend to install all available IM Modules.
    + Improve descriptions (Closes: #643004).
      Thanks to debian-l10n-en, especially Justin B Rye.
    + Recommend to install im-config (>= 0.5), since version 0.5
      has the correct setup for complex situation of IM Modules.
    - Lower plasma-widget-addons to Suggests for fcitx-ui-kimpanel,
      in favor of the usage of this module in gnome-shell and unity.

 -- Aron Xu <aron@debian.org>  Sat, 19 Nov 2011 00:23:14 +0800

fcitx (1:4.1.2-2) unstable; urgency=low

  [ YunQiang Su ]
  * Install usr/share/fcitx/configdesc/fcitx-xim.desc
    into fcitx-module-x11.
  * Install usr/share/fcitx/configdesc/fcitx-chttrans.desc
    into fcitx-modules.
  * debian/patches/01-fix_wm_class_setting.patch:
    - [UPSTREAM] Fix wm_class setting to  make it work better with
      gnome-shell, the tray can displayed as system status icon now.

  [ Aron Xu ]
  * debian/patches/01-dont_fileter_all_release_events.patch:
    - [UPSTREAM] Don't filter all release events.
  * debian/patches/01-fix-duplicate-entry.patch:
    - [UPSTREAM] Add a return to avoid duplicate entry.
  * debian/im-switch/fcitx: use QT4_IM_MODULE instead of QT_IM_MODULE.
  * debian/control: 
    + Recommends to install both GTK2/3 IM Modules.

 -- YunQiang Su <wzssyqa@gmail.com>  Wed, 05 Oct 2011 19:00:56 +0800

fcitx (1:4.1.2-1) unstable; urgency=low

  * New upstream release.
  * Add libkvm-dev [kfreebsd-any] to Build-Depends.

 -- Aron Xu <aron@debian.org>  Sun, 02 Oct 2011 23:45:53 +0800

=== debian/control ===
Source: fcitx
Section: utils
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: Aron Xu <aron@debian.org>, LI Daobing <lidaobing@debian.org>,
  YunQiang Su <wzssyqa@gmail.com>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 8), cmake, intltool (>= 0.35.0),
    libdbus-1-dev (>= 1.1.0), libpango1.0-dev (>= 1.0), libcairo2-dev (>= 1.0),
    libdbus-glib-1-dev, libopencc-dev (>= 0.1.1~), libicu-dev,
    libgtk2.0-dev, libqt4-dev, libgtk-3-dev, libkvm-dev [kfreebsd-any]
Standards-Version: 3.9.2
Homepage: http://code.google.com/p/fcitx/
Vcs-Git: git://git.debian.org/pkg-ime/fcitx.git
Vcs-Browser: http://git.debian.org/?p=pkg-ime/fcitx.git

Package: fcitx
Architecture: all
Depends: ${misc:Depends}, fcitx-bin, fcitx-data, fcitx-modules,
    fcitx-module-x11, fcitx-ui-classic
Recommends: fcitx-pinyin, fcitx-googlepinyin | fcitx-sunpinyin, 
    fcitx-table-wubi | fcitx-table-wbpy, fcitx-config-gtk,
    fcitx-frontend-gtk2, fcitx-frontend-gtk3, fcitx-frontend-qt4,
    im-config (>= 0.5) | im-switch
Suggests: fcitx-tools
Description: Flexible Input Method Framework
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This metapackage pulls in a set of components recommended for most desktop
 users.

Package: fcitx-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: fcitx-data, fcitx-modules
Suggests: fcitx (>= 1:4.1.2)
Replaces: fcitx (<< 1:4.1.2)
Breaks: fcitx (<< 1:4.1.2)
Description: Flexible Input Method Framework - essential binaries
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the essential executable binaries. If you are
 looking for a working input experience, please install the package 
 "fcitx" instead.

Package: fcitx-data
Architecture: all
Depends: ${misc:Depends}
Recommends: fcitx-bin
Suggests: fcitx (>= 1:4.1.2)
Replaces: fcitx (<< 1:4.1.2)
Breaks: fcitx (<< 1:4.1.2)
Description: Flexible Input Method Framework - essential data files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the essential data files. If you are looking for a
 working input experience, please install the package "fcitx" instead.

Package: fcitx-libs
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: fcitx (>= 1:4.1.2)
Replaces: fcitx (<< 1:4.1.2)
Breaks: fcitx (<< 1:4.1.2)
Description: Flexible Input Method Framework - library files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package contains three libraries:
  * libfcitx-core - core functions of Fcitx
  * libfcitx-config - support library for Fcitx configurations
  * libfcitx-utils - utility support library for Fcitx

Package: fcitx-libs-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}, fcitx-libs (= ${binary:Version})
Replaces: fcitx (<< 1:4.1.2)
Breaks: fcitx (<< 1:4.1.2)
Description: Flexible Input Method Framework - library development files
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the library development files.

Package: fcitx-libs-dbg
Architecture: any
Section: debug
Priority: extra
Depends: ${misc:Depends}, fcitx-libs (= ${binary:Version})
Replaces: fcitx (<< 1:4.1.2)
Breaks: fcitx (<< 1:4.1.2)
Description: Flexible Input Method Framework - debugging symbols
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the debugging symbols of the whole Fcitx.

Package: fcitx-ui-kimpanel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-dbus
Replaces: fcitx (<< 1:4.1.2)
Breaks: fcitx (<< 1:4.1.2)
Suggests: plasma-widgets-addons
Description: Flexible Input Method Framework - KIMPanel user interface
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the KIMPanel user interface of Fcitx, which is a
 good choice for KDE4 users. Also it implements a protocol to talk with
 D-Bus, so it might be needed by other desktop environment users like
 GNOME Shell and Unity.

Package: fcitx-ui-classic
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-x11
Recommends: fcitx (>= 1:4.1.2)
Replaces: fcitx (<< 1:4.1.2)
Breaks: fcitx (<< 1:4.1.2)
Description: Flexible Input Method Framework - Classic user interface
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the classic user interface, which is suitable 
 for most users. It also provides the following skins:
  * classic: Fcitx 3.x classic skin ported to new infrastructure
  * dark: the dark skin fits for dark desktop theme
  * default: the default skin

Package: fcitx-frontend-all
Architecture: all
Depends: ${misc:Depends}, fcitx-frontend-gtk2, fcitx-frontend-gtk3, 
    fcitx-frontend-qt4, fcitx-module-x11, fcitx-module-dbus
Description: Flexible Input Method Framework - frontends metapackage
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This metapackage pulls in the following frontends:
  * XIM protocol client
  * GTK+ 2/3 IM Module
  * QT 4 IM Module
  * IPC frontend (based on D-Bus, used by various IM Modules)

Package: fcitx-frontend-gtk2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-dbus
Recommends: fcitx-frontend-gtk3
Description: Flexible Input Method Framework - GTK+ 2 IM Module frontend
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the GTK+ 2 IM Module frontend, which is
 recommended for all desktop users.

Package: fcitx-frontend-gtk3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-dbus
Recommends: fcitx-frontend-gtk2
Description: Flexible Input Method Framework - GTK+ 3 IM Module frontend
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the GTK+ 3 IM Module frontend, which is
 recommended for all desktop users. This is the best solution if you are
 looking for a better input experience with GTK+ 3 applications.

Package: fcitx-frontend-qt4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-dbus
Description: Flexible Input Method Framework - QT 4 IM Module frontend
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .
 It offers a pleasant and modern experience, with intuitive graphical
 configuration tools and customizable skins and mapping tables. It is
 highly modularized and extensible, with GTK+ 2/3 and Qt4 IM Modules, support
 for UIs based on Fbterm, pure Xlib, GTK+, or KDE, and a developer-friendly
 API.
 .
 This package provides the QT 4 IM Module frontend, which is recommended
 for KDE4 desktop users.

Package: fcitx-pinyin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-bin,
  fcitx-data (>= 1:4.1.2), fcitx-modules
Recommends: fcitx (>= 1:4.1.2)
Replaces: fcitx (<< 1:4.1.2)
Breaks: fcitx (<< 1:4.1.2)
Description: Flexible Input Method Framework - classic Pinyin engine
 Fcitx is a input method framework with extension support, which provides
 an interface for entering characters of different scripts in applications
 using a variety of mapping systems. 
 .

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

DEB_BUILD_MULTIARCH=$(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)
GTK2_LIBDIR=$(shell if [ -f /usr/lib/pkgconfig/gtk+-2.0.pc ]; then \
		    	echo "usr\/lib"; \
		    else \
		    	echo "usr\/lib\/$(DEB_BUILD_MULTIARCH)"; \
		    fi)

GTK3_LIBDIR=$(shell if [ -f /usr/lib/pkgconfig/gtk+-3.0.pc ]; then \
		    	echo "usr\/lib"; \
		    else \
		    	echo "usr\/lib\/$(DEB_BUILD_MULTIARCH)"; \
		    fi)

QT4_LIBDIR=$(shell if [ -f /usr/lib/pkgconfig/QtCore.pc ]; then \
		    	echo "usr\/lib"; \
		    else \
		    	echo "usr\/lib\/$(DEB_BUILD_MULTIARCH)"; \
		    fi)

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DENABLE_CAIRO=ON \
	    -DENABLE_DBUS=ON \
	    -DENABLE_PANGO=ON \
	    -DENABLE_DEBUG=ON \
	    -DENABLE_TABLE=ON \
	    -DENABLE_STATIC=ON \
	    -DENABLE_GTK2_IM_MODULE=ON \
	    -DENABLE_GTK3_IM_MODULE=ON \
	    -DENABLE_QT_IM_MODULE=ON \
	    -DENABLE_OPENCC=ON
override_dh_makeshlibs:
	dh_makeshlibs -pfcitx-libs
override_dh_strip:
	dh_strip --dbg-package=fcitx-libs-dbg

override_dh_install:
	sed "s/GTK2_LIBDIR/$(GTK2_LIBDIR)/g" debian/fcitx-frontend-gtk2.install.in >debian/fcitx-frontend-gtk2.install
	sed "s/GTK3_LIBDIR/$(GTK3_LIBDIR)/g" debian/fcitx-frontend-gtk3.install.in >debian/fcitx-frontend-gtk3.install
	sed "s/QT4_LIBDIR/$(QT4_LIBDIR)/g" debian/fcitx-frontend-qt4.install.in >debian/fcitx-frontend-qt4.install
	dh_install

## fcitx 4.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,9 +2,9 @@
 
 project(fcitx)
 
-set(version 4.1.2)
+set(version 4.2.0)
 
-set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
+set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
 
 option(ENABLE_CAIRO "Enable Cairo" ON)
 option(ENABLE_DBUS "Enable DBus Support" ON)
@@ -92,6 +92,11 @@
     endif (OPENCC_FOUND)
 endif (ENABLE_OPENCC)
 
+set(HAVE_XINERAMA 0)
+if (X11_Xinerama_FOUND)
+    set(HAVE_XINERAMA 1)
+endif (X11_Xinerama_FOUND)
+
 if(ENABLE_DEBUG)
     set(_DEBUG)
 endif(ENABLE_DEBUG)
@@ -110,6 +115,7 @@
 set(pkgdatadir ${prefix}/share/${package})
 set(configdescdir ${pkgdatadir}/configdesc)
 set(addonconfigdir ${pkgdatadir}/addon)
+set(imconfigdir ${pkgdatadir}/inputmethod)
 set(localedir ${CMAKE_INSTALL_PREFIX}/share/locale)
 set(includedir  ${CMAKE_INSTALL_PREFIX}/include)
 
@@ -125,6 +131,7 @@
 set(FCITX4_ADDON_INSTALL_DIR ${addondir})
 set(FCITX4_CONFIGDESC_INSTALL_DIR ${configdescdir})
 set(FCITX4_ADDON_CONFIG_INSTALL_DIR ${addonconfigdir})
+set(FCITX4_INPUTMETHOD_CONFIG_INSTALL_DIR ${imconfigdir})
 set(FCITX4_PACKAGE_NAME ${package})
 
 set(CMAKE_C_FLAGS "-Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -fvisibility=hidden ${CMAKE_C_FLAGS}")

=== skin/CMakeLists.txt ===
add_subdirectory(default)
add_subdirectory(classic)
add_subdirectory(dark)

=== data/icon/CMakeLists.txt ===

foreach(size 16 24 32 48 128)
    install(DIRECTORY ${size}x${size} DESTINATION share/icons/hicolor PATTERN .* PATTERN *~ EXCLUDE)
endforeach(size 16 22 24 32 48 128)

install(DIRECTORY scabable DESTINATION share/icons/hicolor PATTERN .* PATTERN *~ EXCLUDE)

=== skin/classic/CMakeLists.txt ===
set(FCITX_CLASSIC_SKIN_FILES
chttrans_active.png chttrans_inactive.png
fullwidth_active.png fullwidth_inactive.png
punc_active.png punc_inactive.png
 active.png  bingchan.png erbi.png  fcitx_skin.conf
 input.png  remind_active.png remind_inactive.png  quwei.png  vk_active.png vk_inactive.png wubi.png wbpy.png ziranma.png
 bar.png cangjie.png  cn.png en.png inactive.png logo.png
 dianbaoma.png shuangpin.png wanfeng.png pinyin.png prev.png next.png menu.png
)

install(FILES ${FCITX_CLASSIC_SKIN_FILES} DESTINATION ${pkgdatadir}/skin/classic)

=== skin/dark/CMakeLists.txt ===
set(FCITX_DARK_SKIN_FILES
active.png  bingchan.png erbi.png  fcitx_skin.conf 
input.png quwei.png wubi.png wbpy.png ziranma.png
bar.png cangjie.png  cn.png en.png  inactive.png logo.png
dianbaoma.png shuangpin.png wanfeng.png pinyin.png prev.png next.png menu.png keyboard.png
remind_active.png remind_inactive.png vk_active.png vk_inactive.png
punc_active.png punc_inactive.png fullwidth_active.png fullwidth_inactive.png
chttrans_active.png chttrans_inactive.png
)

install(FILES ${FCITX_DARK_SKIN_FILES} DESTINATION ${pkgdatadir}/skin/dark)

=== src/frontend/gtk2/CMakeLists.txt ===
if(ENABLE_GTK2_IM_MODULE)

PKG_CHECK_MODULES(GTK2 REQUIRED "gtk+-2.0" )

_pkgconfig_invoke("gtk+-2.0" GTK2 BINARY_VERSION "" "--variable=gtk_binary_version")
_pkgconfig_invoke("gtk+-2.0" GTK2 LIBDIR "" "--variable=libdir")
set(GTK2_IM_MODULEDIR
 "${GTK2_LIBDIR}/gtk-2.0/${GTK2_BINARY_VERSION}/immodules"
)

include_directories(${GTK2_INCLUDE_DIRS})
include_directories(${DBUS_GLIB_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
link_directories(${GTK2_LIBRARY_DIRS} ${DBUS_GLIB_LIBRARY_DIRS})

add_custom_command(OUTPUT marshall.c
                   COMMAND ${GLIB_GENMARSHAL} --body --prefix=fcitx_marshall ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.c
)
add_custom_command(OUTPUT marshall.h
                   COMMAND ${GLIB_GENMARSHAL} --header --prefix=fcitx_marshall ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.h
)

set(FCITX_GTK2_IM_MODULE_SOURCES
    fcitxim.c
    fcitximcontext.c
    client.c
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.c
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.h
)

add_library(im-fcitx MODULE ${FCITX_GTK2_IM_MODULE_SOURCES})
set_target_properties( im-fcitx PROPERTIES PREFIX "" COMPILE_FLAGS "-fvisibility=hidden" LINK_FLAGS "-Wl,--no-undefined")
target_link_libraries( im-fcitx ${GTK2_LIBRARIES} ${DBUS_GLIB_LIBRARIES} fcitx-utils)

install(TARGETS im-fcitx DESTINATION ${GTK2_IM_MODULEDIR})

endif(ENABLE_GTK2_IM_MODULE)

=== src/frontend/gtk3/CMakeLists.txt ===
if(ENABLE_GTK3_IM_MODULE)

PKG_CHECK_MODULES(GTK3 REQUIRED "gtk+-3.0" )

_pkgconfig_invoke("gtk+-3.0" GTK3 BINARY_VERSION "" "--variable=gtk_binary_version")
_pkgconfig_invoke("gtk+-3.0" GTK3 LIBDIR "" "--variable=libdir")
set(GTK3_IM_MODULEDIR
 "${GTK3_LIBDIR}/gtk-3.0/${GTK3_BINARY_VERSION}/immodules"
)

include_directories(${GTK3_INCLUDE_DIRS})
include_directories(${DBUS_GLIB_INCLUDE_DIRS})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
link_directories(${GTK3_LIBRARY_DIRS} ${DBUS_GLIB_LIBRARY_DIRS})

add_custom_command(OUTPUT marshall.c
                   COMMAND ${GLIB_GENMARSHAL} --body --prefix=fcitx_marshall ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.c
)
add_custom_command(OUTPUT marshall.h
                   COMMAND ${GLIB_GENMARSHAL} --header --prefix=fcitx_marshall ${PROJECT_SOURCE_DIR}/src/frontend/gtk-common/marshall.list > marshall.h
)

set(FCITX_GTK3_IM_MODULE_SOURCES
    ../gtk2/fcitxim.c
    ../gtk2/fcitximcontext.c
    ../gtk2/client.c
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.c
    ${CMAKE_CURRENT_BINARY_DIR}/marshall.h
)

add_library(im-fcitx-gtk3 MODULE ${FCITX_GTK3_IM_MODULE_SOURCES})
set_target_properties( im-fcitx-gtk3 PROPERTIES PREFIX "" COMPILE_FLAGS "-fvisibility=hidden" OUTPUT_NAME "im-fcitx" LINK_FLAGS "-Wl,--no-undefined")

target_link_libraries( im-fcitx-gtk3 ${GTK3_LIBRARIES} ${DBUS_GLIB_LIBRARIES} fcitx-utils)

install(TARGETS im-fcitx-gtk3 DESTINATION ${GTK3_IM_MODULEDIR})

endif(ENABLE_GTK3_IM_MODULE)

=== src/frontend/qt/CMakeLists.txt ===
--- 
+++ 
@@ -22,9 +22,7 @@
     qtim_fcitx_SRCS
     fcitx-plugin.cpp
     fcitx-input-context.cpp
-    fcitxkeyuni.cpp
 )
-
 
 QT4_ADD_DBUS_INTERFACE(qtim_fcitx_SRCS
     org.fcitx.Fcitx.InputContext.xml

=== src/frontend/xim/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/lib)
include_directories(${PROJECT_SOURCE_DIR}/src/frontend/xim/lib)
include_directories(${X11_X11_INCLUDE_PATH})

set(fcitx_xim_SOURCES
    IC.c
    xim.c
    ximhandler.c
    ximconfig.c
)

set(Ximd_SOURCES
    lib/FrameMgr.c
    lib/i18nAttr.c
    lib/i18nClbk.c
    lib/i18nIc.c
    lib/i18nIMProto.c
    lib/i18nMethod.c
    lib/i18nPtHdr.c
    lib/i18nUtil.c
    lib/i18nX.c
    lib/IMConn.c
    lib/IMMethod.c
    lib/IMValues.c
)


fcitx_add_addon(fcitx-xim ${fcitx_xim_SOURCES} ${Ximd_SOURCES})
target_link_libraries( fcitx-xim ${X11_LIBRARIES})

fcitx_add_addon_conf_file(fcitx-xim.conf)
fcitx_add_configdesc_file(fcitx-xim.desc)

=== src/ui/classic/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${CAIRO_XLIB_INCLUDE_DIRS})
link_directories(${CAIRO_XLIB_LIBRARY_DIRS})

if (_ENABLE_PANGO)
    include_directories ( ${PANGOCAIRO_INCLUDE_DIRS} )
    link_directories(${PANGOCAIRO_LIBRARY_DIRS})
else (_ENABLE_PANGO)
    include_directories ( ${FONTCONFIG_INCLUDE_DIRS} )
    link_directories(${FONTCONFIG_LIBRARY_DIRS})
endif (_ENABLE_PANGO)

set(fcitx_classic_ui_SOURCES
    classicui.c
    classicuiconfig.c
    InputWindow.c
    MainWindow.c
    MenuWindow.c
    MessageWindow.c
    AboutWindow.c
    TrayWindow.c
    tray.c
    skinconfig.c
    skin.c
    ../cairostuff/font.c
    ../cairostuff/cairostuff.c
)

set(CLASSICUI_DESC_FILES
    fcitx-classic-ui.desc
    skin.desc
)

fcitx_add_addon(fcitx-classic-ui ${fcitx_classic_ui_SOURCES})
target_link_libraries( fcitx-classic-ui ${X11_LIBRARIES} ${CAIRO_XLIB_LIBRARIES} )

if (_ENABLE_PANGO)
    target_link_libraries( fcitx-classic-ui ${PANGOCAIRO_LIBRARIES} )
else (_ENABLE_PANGO)
    target_link_libraries( fcitx-classic-ui ${FONTCONFIG_LIBRARIES} )
endif (_ENABLE_PANGO)
fcitx_add_addon_header(classicui classicuiinterface.h)
fcitx_add_addon_conf_file(fcitx-classic-ui.conf)
fcitx_add_configdesc_file(${CLASSICUI_DESC_FILES})

add_custom_target(installer-desktopfile ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/fcitx-skin-installer.desktop)

install(FILES fcitx-skin-installer.sh RENAME fcitx-skin-installer DESTINATION ${bindir} PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
intltool_merge_translation(${CMAKE_CURRENT_SOURCE_DIR}/fcitx-skin-installer.desktop.in ${CMAKE_CURRENT_BINARY_DIR}/fcitx-skin-installer.desktop )
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/fcitx-skin-installer.desktop DESTINATION share/applications/)
install(FILES x-fskin.xml DESTINATION share/mime/packages/ )

=== debian/changelog ===
fcitx (1:4.2.0-1) unstable; urgency=low

  * New upstream release:
    - New API, with global context support.
    - Allow first input method to be in Inactive status.
    - Decrease memory usage of table engine and pinyin engine.
    - Runtime replacement of existing instance.
    - Improved table engine.
  * Full Multi-Arch support:
    - Co-installable libraries and IM Modules.
    - Build-time dynamic Multi-Arch path and markup detection.

 -- Aron Xu <aron@debian.org>  Sun, 05 Feb 2012 15:51:12 +0800

fcitx (1:4.1.2-6) unstable; urgency=low

  * debian/rules:
    - Enable hardening build flags.
  * debian/control:
    - Rename fcitx-libs-dbg to fcitx-dbg.
  * debian/patches:
    - [UPSTREAM] Cherry-pick bug fixes from upstream master
      (0010 0011 0012).

 -- Aron Xu <aron@debian.org>  Fri, 03 Feb 2012 04:12:43 +0800

fcitx (1:4.1.2-5) unstable; urgency=low

  * debian/patches/02_dont_show_dialog_first_run.patch:
    - Don't show dialog about immodules, which will confuse users,
      while we use im-config.
  * debian/patches/02_dbus_max_retry_times.patch:
    -  MAX_RETRY_TIMES to 20 from 5

 -- YunQiang Su <wzssyqa@gmail.com>  Wed, 21 Dec 2011 22:01:57 +0800

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,9 @@
 Section: utils
 Priority: optional
 Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
-Uploaders: Aron Xu <aron@debian.org>, LI Daobing <lidaobing@debian.org>,
-  YunQiang Su <wzssyqa@gmail.com>
+Uploaders: Aron Xu <aron@debian.org>, YunQiang Su <wzssyqa@gmail.com>
 DM-Upload-Allowed: yes
-Build-Depends: debhelper (>= 8), cmake, intltool (>= 0.35.0),
+Build-Depends: debhelper (>= 9), cmake, intltool (>= 0.35.0),
     libdbus-1-dev (>= 1.1.0), libpango1.0-dev (>= 1.0), libcairo2-dev (>= 1.0),
     libdbus-glib-1-dev, libopencc-dev (>= 0.1.1~), libicu-dev,
     libgtk2.0-dev, libqt4-dev, libgtk-3-dev, libkvm-dev [kfreebsd-any]
@@ -41,9 +40,9 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: fcitx-data, fcitx-modules
-Suggests: fcitx (>= 1:4.1.2)
-Replaces: fcitx (<< 1:4.1.2)
-Breaks: fcitx (<< 1:4.1.2)
+Suggests: fcitx (>= 1:4.2.0)
+Replaces: fcitx (<< 1:4.2.0)
+Breaks: fcitx (<< 1:4.2.0)
 Description: Flexible Input Method Framework - essential binaries
  Fcitx is a input method framework with extension support, which provides
  an interface for entering characters of different scripts in applications
@@ -63,9 +62,10 @@
 Architecture: all
 Depends: ${misc:Depends}
 Recommends: fcitx-bin
-Suggests: fcitx (>= 1:4.1.2)
-Replaces: fcitx (<< 1:4.1.2)
-Breaks: fcitx (<< 1:4.1.2)
+Suggests: fcitx (>= 1:4.2.0)
+Replaces: fcitx (<< 1:4.2.0)
+Breaks: fcitx (<< 1:4.2.0)
+Multi-arch: foreign
 Description: Flexible Input Method Framework - essential data files
  Fcitx is a input method framework with extension support, which provides
  an interface for entering characters of different scripts in applications
@@ -83,10 +83,12 @@
 Package: fcitx-libs
 Architecture: any
 Section: libs
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Suggests: fcitx (>= 1:4.1.2)
-Replaces: fcitx (<< 1:4.1.2)
-Breaks: fcitx (<< 1:4.1.2)
+Suggests: fcitx (>= 1:4.2.0)
+Replaces: fcitx (<< 1:4.2.0)
+Breaks: fcitx (<< 1:4.2.0)
 Description: Flexible Input Method Framework - library files
  Fcitx is a input method framework with extension support, which provides
  an interface for entering characters of different scripts in applications
@@ -107,8 +109,8 @@
 Architecture: any
 Section: libdevel
 Depends: ${misc:Depends}, fcitx-libs (= ${binary:Version})
-Replaces: fcitx (<< 1:4.1.2)
-Breaks: fcitx (<< 1:4.1.2)
+Replaces: fcitx (<< 1:4.2.0)
+Breaks: fcitx (<< 1:4.2.0)
 Description: Flexible Input Method Framework - library development files
  Fcitx is a input method framework with extension support, which provides
  an interface for entering characters of different scripts in applications
@@ -122,13 +124,14 @@
  .
  This package provides the library development files.
 
-Package: fcitx-libs-dbg
+Package: fcitx-dbg
 Architecture: any
 Section: debug
 Priority: extra
 Depends: ${misc:Depends}, fcitx-libs (= ${binary:Version})
-Replaces: fcitx (<< 1:4.1.2)
-Breaks: fcitx (<< 1:4.1.2)
+Provides: fcitx-libs-dbg
+Replaces: fcitx (<< 1:4.2.0), fcitx-libs-dbg
+Breaks: fcitx (<< 1:4.2.0), fcitx-libs-dbg
 Description: Flexible Input Method Framework - debugging symbols
  Fcitx is a input method framework with extension support, which provides
  an interface for entering characters of different scripts in applications
@@ -145,8 +148,9 @@
 Package: fcitx-ui-kimpanel
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-dbus
-Replaces: fcitx (<< 1:4.1.2)
-Breaks: fcitx (<< 1:4.1.2)
+Recommends: kdebase-bin
+Replaces: fcitx (<< 1:4.2.0)
+Breaks: fcitx (<< 1:4.2.0)
 Suggests: plasma-widgets-addons
 Description: Flexible Input Method Framework - KIMPanel user interface
  Fcitx is a input method framework with extension support, which provides
@@ -167,9 +171,9 @@
 Package: fcitx-ui-classic
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-x11
-Recommends: fcitx (>= 1:4.1.2)
-Replaces: fcitx (<< 1:4.1.2)
-Breaks: fcitx (<< 1:4.1.2)
+Recommends: fcitx (>= 1:4.2.0), zenity
+Replaces: fcitx (<< 1:4.2.0)
+Breaks: fcitx (<< 1:4.2.0)
 Description: Flexible Input Method Framework - Classic user interface
  Fcitx is a input method framework with extension support, which provides
  an interface for entering characters of different scripts in applications
@@ -210,6 +214,8 @@
 
 Package: fcitx-frontend-gtk2
 Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-dbus
 Recommends: fcitx-frontend-gtk3
 Description: Flexible Input Method Framework - GTK+ 2 IM Module frontend
@@ -228,6 +234,8 @@
 
 Package: fcitx-frontend-gtk3
 Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-module-dbus
 Recommends: fcitx-frontend-gtk2
 Description: Flexible Input Method Framework - GTK+ 3 IM Module frontend
@@ -265,12 +273,8 @@
 Package: fcitx-pinyin
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, fcitx-bin,
-  fcitx-data (>= 1:4.1.2), fcitx-modules
-Recommends: fcitx (>= 1:4.1.2)
-Replaces: fcitx (<< 1:4.1.2)
-Breaks: fcitx (<< 1:4.1.2)
+  fcitx-data (>= 1:4.2.0), fcitx-modules
+Recommends: fcitx (>= 1:4.2.0)
+Replaces: fcitx (<< 1:4.2.0)
+Breaks: fcitx (<< 1:4.2.0)
 Description: Flexible Input Method Framework - classic Pinyin engine
- Fcitx is a input method framework with extension support, which provides
- an interface for entering characters of different scripts in applications
- using a variety of mapping systems. 
- .

=== debian/rules ===
#!/usr/bin/make -f
include debian/variables.mk
include debian/gencontrol.mk
%:
	dh $@
override_dh_auto_configure: gen_control
	dh_auto_configure -- \
	    -DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
	    -DENABLE_CAIRO=ON \
	    -DENABLE_DBUS=ON \
	    -DENABLE_PANGO=ON \
	    -DENABLE_DEBUG=ON \
	    -DENABLE_TABLE=ON \
	    -DENABLE_STATIC=ON \
	    -DENABLE_GTK2_IM_MODULE=ON \
	    -DENABLE_GTK3_IM_MODULE=ON \
	    -DENABLE_QT_IM_MODULE=ON \
	    -DENABLE_OPENCC=ON
override_dh_makeshlibs:
	dh_makeshlibs -pfcitx-libs
override_dh_strip:
	dh_strip --dbg-package=fcitx-dbg
